---
title: AudioBuffer
slug: Web/API/AudioBuffer
tags:
  - API
  - AudioBuffer
  - Interface
  - Reference
  - Web Audio API
---
<p>{{APIRef("Web Audio API")}}</p>

<p>The <strong><code>AudioBuffer</code></strong> interface represents a short audio asset residing in memory, created from an audio file using the {{ domxref("AudioContext.decodeAudioData()") }} method, or from raw data using {{ domxref("AudioContext.createBuffer()") }}. Once put into an AudioBuffer, the audio can then be played by being passed into an {{ domxref("AudioBufferSourceNode") }}.</p>

<p>Objects of these types are designed to hold small audio snippets, typically less than 45 s. For longer sounds, objects implementing the {{domxref("MediaElementAudioSourceNode")}} are more suitable. The buffer contains data in the following format: non-interleaved IEEE754 32-bit linear PCM with a nominal range between <code>-1</code> and <code>+1</code>, that is, 32bits floating point buffer, with each samples between -1.0 and 1.0. If the {{domxref("AudioBuffer")}} has multiple channels, they are stored in separate buffer.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("AudioBuffer.AudioBuffer", "AudioBuffer()")}}</dt>
 <dd>Creates and returns a new <code>AudioBuffer</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("AudioBuffer.sampleRate")}} {{readonlyInline}}</dt>
 <dd>Returns a float representing the sample rate, in samples per second, of the PCM data stored in the buffer.</dd>
 <dt>{{domxref("AudioBuffer.length")}} {{readonlyInline}}</dt>
 <dd>Returns an integer representing the length, in sample-frames, of the PCM data stored in the buffer.</dd>
 <dt>{{domxref("AudioBuffer.duration")}} {{readonlyInline}}</dt>
 <dd>Returns a double representing the duration, in seconds, of the PCM data stored in the buffer.</dd>
 <dt>{{domxref("AudioBuffer.numberOfChannels")}} {{readonlyInline}}</dt>
 <dd>Returns an integer representing the number of discrete audio channels described by the PCM data stored in the buffer.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("AudioBuffer.getChannelData()")}}</dt>
 <dd>Returns a {{jsxref("Float32Array")}} containing the PCM data associated with the channel, defined by the <code>channel</code> parameter (with <code>0</code> representing the first channel).</dd>
 <dt>{{domxref("AudioBuffer.copyFromChannel()")}}</dt>
 <dd>Copies the samples from the specified channel of the <span class="idlType"><code>AudioBuffer</code></span> to the <code>destination</code> array.</dd>
 <dt>{{domxref("AudioBuffer.copyToChannel()")}}</dt>
 <dd>Copies the samples to the specified channel of the <span class="idlType"><code>AudioBuffer</code></span>, from the <code>source</code> array.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following simple example shows how to create an <code>AudioBuffer</code> and fill it with random white noise. You can find the full source code at our <a href="https://github.com/mdn/webaudio-examples">webaudio-examples</a> repository; a <a href="https://mdn.github.io/webaudio-examples/audio-buffer/">running live</a> version is also available.</p>

<pre class="brush: js">var audioCtx = new (window.AudioContext || window.webkitAudioContext)();

// Create an empty three-second stereo buffer at the sample rate of the AudioContext
var myArrayBuffer = audioCtx.createBuffer(2, audioCtx.sampleRate * 3, audioCtx.sampleRate);

// Fill the buffer with white noise;
// just random values between -1.0 and 1.0
for (var channel = 0; channel &lt; myArrayBuffer.numberOfChannels; channel++) {
  // This gives us the actual array that contains the data
  var nowBuffering = myArrayBuffer.getChannelData(channel);
  for (var i = 0; i &lt; myArrayBuffer.length; i++) {
    // Math.random() is in [0; 1.0]
    // audio needs to be in [-1.0; 1.0]
    nowBuffering[i] = Math.random() * 2 - 1;
  }
}

// Get an AudioBufferSourceNode.
// This is the AudioNode to use when we want to play an AudioBuffer
var source = audioCtx.createBufferSource();

// set the buffer in the AudioBufferSourceNode
source.buffer = myArrayBuffer;

// connect the AudioBufferSourceNode to the
// destination so we can hear the sound
source.connect(audioCtx.destination);

// start the source playing
source.start();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#audiobuffer', 'AudioBuffer')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBuffer")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
